module(..., package.seeall)

--LODO add support for music meta-data by adding nested tables
--[[
should allow for:
    music duration for fade-out
    repeats
    stuff?
--]]

local fx = {}
local music = {}
local track
local stage

function init() --bruv
    audio.reserveChannels(1)
end

local function dropAudio() --like it's hot
    if(music[1])then
        for i=1, #music, 1 do
            audio.dispose(music[i])
            music[i] = nil
        end
    end

    if(fx[1])then
        for j=1, #fx, 1 do
            audio.dispose(fx[j])
            fx[j] = nil
        end
    end
end

local function rotateMusic()
    audio.setVolume(settings.userSettings.musicVol/2, {channel=1})
    track = track + 1
    if(track > #music)then
        track = 1
    end
    audio.play(music[track], {loops=1, channel=1, onComplete=rotateMusic})
end

function menuLoad()
    if(stage ~= "menu")then
        stage = "menu"
        audio.fadeOut({channel=0, time=500})
        audio.setVolume(settings.userSettings.musicVol/2)
        dropAudio()
        if(settings.userSettings.music == true)then
            music[1] = audio.loadStream("sound/menu.mp3")

            track = mRand((#music))
            rotateMusic()
        end
        if(settings.userSettings.fx == true)then
            fx[1] = audio.loadSound("sound/button.wav")
        end
    end
end

function gameLoad()
    if(stage ~= "game")then
        stage = "game"
        audio.fadeOut({channel=0, time=500})
        audio.setVolume(settings.userSettings.musicVol/2)
        dropAudio()
        if(settings.userSettings.music == true)then
            music[1] = audio.loadStream("sound/play_banshee.mp3")
            music[2] = audio.loadStream("sound/play_madness.mp3")
            music[3] = audio.loadStream("sound/play_rise.mp3")

            track = mRand(#music)
            rotateMusic()
        end
        if(settings.userSettings.fx == true)then
            fx[1] = audio.loadSound("sound/shoot.wav")
            fx[2] = audio.loadSound("sound/bump.wav")
            fx[3] = audio.loadSound("sound/pickup.wav")
            fx[4] = audio.loadSound("sound/death.wav")
        end
    end
end

function playEffect(arg)
    if(arg)then
        if(settings.userSettings.fx == true)then
            local ch = audio.findFreeChannel()
            audio.play(fx[arg], {channel=ch})
            audio.setVolume(settings.userSettings.fxVol, {channel=ch})
        end
    end
end

function reset()
    stage = "reset"
end
