module(...,package.seeall)

function new()
    short.unRequire("generator")
    short.unRequire("play")
    local Scene = display.newGroup()
    local GUI = display.newGroup()
    local background = display.newGroup()
    physics.stop()
    physics = nil

    local back = display.newImage("images/menu_back.png", _W, _H)
    back.alpha = 0.75
    back:setReferencePoint(display.CenterReferencePoint)
    back.x = _W/2
    back.y = _H/2
    back.rotation = 90

    local title = display.newImage("images/died.png")
    title:setReferencePoint(display.CenterReferencePoint)
    title.x = _W - title.height - 20
    title.y = _H/2
    title.xScale = (_H - (_H/4))/title.width
    title.yScale = _W/10/title.height
    title.rotation = 90

    local function common(obj)
        obj:setReferencePoint(display.CenterReferencePoint)
        obj.y = _H/2
        obj.rotation = 90
        obj.xScale = obj.width/(_H/2)
        obj.yScale = obj.height/(_W/3)
    end

    local again = display.newImage("images/btn_again.png", 50, 50)
    common(again)
    again.x = title.x - title.height/2 - again.height/2 -_W/40
    again.scene = "play"

    local menu = display.newImage("images/btn_menu.png", 50, 50)
    common(menu)
    menu.x = again.x - again.height/2 -_W/20
    menu.scene = "menu"

    local scoreLabel = display.newText("You scored: " .. short.getScore(), menu.x - menu.height/2 -_W/20, _H/2, native.systemfont, 32)
    scoreLabel.rotation = 90
    scoreLabel.x = _W/12
    scoreLabel.y = _H/2
    GUI:insert(scoreLabel)

    local function changeScene(e)
        if(e.phase == "began")then
            --e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            --e.target:setTextColor(255,255,255)
        elseif(e.phase == "cancelled" or e.phase == "ended") then
            conductor.playEffect(1)
            background:removeSelf()
            GUI:removeSelf()
            background = nil
            GUI = nil
            director:changeScene(e.target.scene)
        end
    end

    conductor.menuLoad()

    menu:addEventListener("touch", changeScene)
    again:addEventListener("touch", changeScene)

    GUI:insert(menu)
    GUI:insert(again)
    GUI:insert(title)
    
    background:insert(back)
    
    Scene:insert(background)
    Scene:insert(GUI)

    return Scene
end