module(...,package.seeall)

function new()
    local Scene = display.newGroup()
    local GUI = display.newGroup()
    local background = display.newGroup()

    local exp = display.newText("Avoid debris and the expanding sun!\n\nTap to Fire\nTouch and hold to accelerate\n\nBeware, you only have limited fuel",0, _H/2, native.systemFont, 36)
    exp.rotation = 90
    exp.x = _W/2
    exp.y = _H/2
    GUI:insert(exp)

    local back = display.newImage("images/menu_back.png", _W, _H)
    back.alpha = 0.75
    back:setReferencePoint(display.CenterReferencePoint)
    back.x = _W/2
    back.y = _H/2
    back.rotation = 90
    background:insert(back)

    local function changeScene(e)
        if(e.phase == "began")then
            --e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            --e.target:setTextColor(255,255,255)
        elseif(e.phase == "cancelled" or e.phase == "ended") then
            conductor.playEffect(1)
            background:removeSelf()
            GUI:removeSelf()
            background = nil
            GUI = nil
            director:changeScene(e.target.scene)
        end
    end

    local menu = display.newImage("images/btn_menu.png", 50, 50)
    menu:setReferencePoint(display.CenterReferencePoint)
    menu.x = _W/12
    menu.y = _H/2
    menu.rotation = 90
    menu.scene = "menu"
    menu:addEventListener("touch", changeScene)
    GUI:insert(menu)

    Scene:insert(background)
    Scene:insert(GUI)

    return Scene
end