module(..., package.seeall)

function new()
    local Scene = display.newGroup()

    local background = display.newGroup()
    local GUI = display.newGroup()

    local function common(obj)
        obj:setReferencePoint(display.CenterReferencePoint)
        obj.y = _H/2
        obj.rotation = 90
    end

    local title = display.newText("Options", 0, 0, native.systemFont, 48)
    common(title)
    title.x = _W - _W/10
    title.y = _H/2

    --LODO replace with images
    --LODO volume sliders
    local musicBtn = display.newText("", 0, 0, native.systemFont, 36)
    local fxBtn = display.newText("", 0, 0, native.systemFont, 36)
    --local spaceBtn = display.newText("", 0, 0, native.systemFont, 36)
    --local cutSkipBtn = display.newText("", 0, 0, native.systemFont, 36)
    local backBtn = display.newText("Back", 0, 0, native.systemFont, 36)

    common(musicBtn)
    common(fxBtn)
    common(backBtn)

    musicBtn.x = title.x - title.height/2 - musicBtn.height -_W/10
    fxBtn.x = musicBtn.x - musicBtn.height/2 - _W/10
    backBtn.x = fxBtn.x - fxBtn.height/2 - _W/10

    musicBtn.var = "music"
    fxBtn.var = "fx"
    --spaceBtn.var = "space"
    --cutSkipBtn.var = "cutSkip"
    backBtn.scene = "menu"

    local function changeScene(e)
        if(e.phase == "began")then
            --e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            --e.target:setTextColor(255,255,255)
        elseif(e.phase == "cancelled" or e.phase == "ended") then
            conductor.playEffect(1)
            background:removeSelf()
            GUI:removeSelf()
            background = nil
            GUI = nil
            director:changeScene(e.target.scene)
        end
    end

    local function updateLabels()
        --LODO image toggler
        if(settings.userSettings.music == true)then
            musicBtn.text = "Music ON"
        else
            musicBtn.text = "Music OFF"
        end

        if(settings.userSettings.fx == true)then
            fxBtn.text = "Sound ON"
        else
            fxBtn.text = "Sound OFF"
        end
        --[[
        if(settings.usersettings.space == true)then
            spaceBtn.text = "Realistic Sound ON"
        else
            spaceBtn.text = "Realistic Sound OFF"
        end

        if(settings.usersettings.cutSkip == true)then
            cutSkipBtn.text = "All Cutscenes Will Be Skipped"
        else
            cutSkipBtn.text = "All Cutscenes Will Not Be Skipped"
        end
        --]]
    end

    local function toggleState(e)
        if(e.phase == "began")then
            e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            e.target:setTextColor(255,255,255)
        elseif(e.phase == "ended" or e.phase == "cancelled")then
            e.target:setTextColor(255,255,255)
            if(settings.userSettings[e.target.var] == true)then
                settings.userSettings[e.target.var] = false
            else
                settings.userSettings[e.target.var] = true
            end
            print("" .. e.target.var)
            conductor.reset()
            audio.stop()
            conductor.menuLoad()
            conductor.playEffect(1)
            updateLabels()
        end
    end

    musicBtn:addEventListener("touch", toggleState)
    fxBtn:addEventListener("touch", toggleState)
    --spaceBtn:addEventListener("touch", toggleState)
    --cutSkipBtn:addEventListener("touch", toggleState)
    backBtn:addEventListener("touch", changeScene)

    local back = display.newImage("images/menu_back.png", _W, _H)
    back.alpha = 0.75
    back:setReferencePoint(display.CenterReferencePoint)
    back.x = _W/2
    back.y = _H/2
    back.rotation = 90

    GUI:insert(title)
    GUI:insert(musicBtn)
    GUI:insert(fxBtn)
    --GUI:insert(spaceBtn)
    --GUI:insert(cutSkipBtn)

    background:insert(back)

    Scene:insert(background)
    Scene:insert(GUI)

    updateLabels()

    return Scene
end