module(..., package.seeall)

--TODO physics is screwy
--TODO force number real low

function new()
    local Scene = display.newGroup()

    --local holdingCell = {}
    --local deathForce = 1000
    local hits
    local fuelResto = 25
    local cleanup = false
    local active = false
    local aBase = 2

    local background = display.newGroup()
    local enviroment = display.newGroup()
    local foreground = display.newGroup()
    local GUI = display.newGroup()

    local score = 0
    local scoreLabel = display.newText("Score: " .. score, _W - _W/10, _H/2, native.systemfont, 22)
    scoreLabel.rotation = 90
    local function updateScore()
        score = score + 1
        scoreLabel.text = "Score: " .. score
    end
    GUI:insert(scoreLabel)

    --[[
    local back = display.newImageRect("images/back.png", _H*1.25, _H*1.25)
    back:setReferencePoint(display.centerReferencePoint)
    back.x = _W/2
    back.y = _H/2
    --back.xScale = _H*2
    --back.yScale = _H*2
    --back.width = _H
    --back.height = _H
    --back.alpha = 0.45
    background:insert(back)
    --]]

    --local sun = display.newImage("images/sun.png", _W/4, _W/4)
    --enviroment:insert(sun)
    --sun.x = _W/2
    --sun.y = _H/2

    sprite = require("sprite")
    physics = require("physics")
    physics.start()
    physics.setGravity(0,0)
    --physics.setDrawMode("hybrid")
    physics.setScale(100)

    local generator = require("generator")
    local solar = generator.createSolar()

    foreground.x = _W/2-solar.plyr.x
    foreground.y = _H/2-solar.plyr.y
    enviroment.x = _W/2-solar.plyr.x
    enviroment.y = _H/2-solar.plyr.y

    enviroment:insert(solar.sunOrbit)

    local fuel = display.newRect(15, 10, _W - 30, 10)
    fuel:setFillColor(0,255,0)
    GUI:insert(fuel)
    fuel.percent = 100

    local function updateFuel(change)
        if(change > 0)then
            fuel.percent = math.max(100, fuel.percent + change)
        else
            fuel.percent = math.max(0, fuel.percent + change)
        end
        if(fuel.percent > 0)then
            fuel.alpha = 1
            fuel.xScale = (fuel.percent / 100)
            if(fuel.percent > 75)then
                fuel:setFillColor(0, 255, 0)
            elseif(fuel.percent > 25)then
                fuel:setFillColor(255, 255, 0)
            else
                fuel:setFillColor(255, 65, 0)
            end
        else
            fuel:setFillColor(255, 0, 0)
        end
    end

    local shipSheet = sprite.newSpriteSheetFromData("images/ship_sheet.png", require("sheet_ship").getSpriteSheetData())
    local shipSet = sprite.newSpriteSet(shipSheet,1,4)
    sprite.add(shipSet, "thrust", 3, 2, 500, 0)
    sprite.add(shipSet, "smoke", 1,2,500,0)

    local player = sprite.newSprite(shipSet)
    --player.yScale = 0.5
    --player.xScale = 0.5
    player.type = "player"
    player:prepare("smoke")
    player:play()
    --TODO dynamic this
    player.xScale = 0.5
    player.yScale = 0.5
    --local player = display.newImageRect("images/Ship.png", _W/8*1.27, _W/8)
    player:setReferencePoint(display.centerReferencePoint)
    foreground:insert(player)
    --player.y = _H/2
    --player.x = _W/2
    player.x = solar.plyr.x
    player.y = solar.plyr.y
    player.damage = 0

    local pw = player.width*player.xScale/2
    local ph = player.height*player.yScale/2
    local corners = {-pw,-ph,pw,-ph,pw,ph,-pw,ph}
    pw = nil
    ph = nil
    physics.addBody(player, "dynamic", {shape=corners})
    player.isBullet = true
    player.moveTimer = nil

    function player:die()
        print("Palyer dies")
        short.setScore(score)
        conductor.playEffect(4)
        cleanup = true
        Runtime:removeEventListener("tap", player)
        Runtime:removeEventListener("touch", player)
        --physics.stop()
        shipSheet:dispose()
        solar:cleanUp()
        solar.sunOrbit:removeSelf()
        solar = nil
        background:removeSelf()
        GUI:removeSelf()
        foreground:removeSelf()
        enviroment:removeSelf()
        background = nil
        GUI = nil
        foreground = nil
        enviroment = nil
        sprite = nil
        timer.performWithDelay(10, short.kill)
        --physics = nil
        --director:changeScene("dead")
        --Runtime:addEventListener("enterFrame", updateAll)
    end

    function player:postCollision(e)
        print("post Collide with " .. e.other.type)
        print("collision force: " .. e.force)
        print("collider location: (" .. e.other.x .. "," .. e.other.y .. ") player location: (" .. player.x .. "," .. player.y .. ")")
        if(active == true)then
            if(e.other.type == "fuel")then
                updateFuel(fuelResto)
                conductor.playEffect(3)
            elseif(e.other.type == "sun")then
                player:die()
            elseif(e.other.type == "projectile")then
            elseif(e.other.type == "moon" or  e.other.type == "debris")then
                conductor.playEffect(2)
                player.damage = player.damage + 1
                if(player.damage > 15)then
                    player:die()
                end
                --[[
                player.damage = player.damage + e.force
                if(player.damage < deathForce)then
                    player:die()
                end
                --]]
            end
        else
            e.other:removeSelf()
        end
    end
    player:addEventListener("postCollision", player)

    local movables = {plyr=player, enemies={}, debris={}, projectiles={}}

    local function fire(e)
        if(cleanup ~= true)then
            if(not movables.projectiles.plyrProj)then
                local plyrProj = display.newImageRect("images/projectile.png", _W/30, _W/30)
                plyrProj.type = "projectile"
                enviroment:insert(plyrProj)
                plyrProj.rotation = player.rotation
                --plyrProj.x = player.x
                --plyrProj.y = player.y

                --plyrProj.x = player.x + ((1/(90/(player.rotation % 90))) * (player.width/2))
                --plyrProj.y = player.y + ((1 - (1/(90/(player.rotation % 90)))) * (player.height/2))
                if(not((plyrProj.rotation > 0) and (plyrProj.rotation < 180)))then
                    plyrProj.y = player.y - ((1 - (1/(90/(player.rotation % 90)))) * (player.height/2))
                else
                    plyrProj.y = player.y + ((1 - (1/(90/(player.rotation % 90)))) * (player.height/2))
                end
                if(not(plyrProj.rotation < 90))then
                    plyrProj.x = player.x - ((1/(90/(player.rotation % 90))) * (player.width/2))
                else
                    plyrProj.x = player.x + ((1/(90/(player.rotation % 90))) * (player.width/2))
                end

                --[[
                local rad = player.rotation * math.pi / 180
                if(player.rotation > 180)then
                    plyrProj.x = _W - math.sin(rad)*(player.height/2) + player.x
                    plyrProj.y = _H - math.sin(rad)*(player.width/2) + player.y
                else
                    plyrProj.x = _W + math.sin(rad)*(player.height/2) + player.x
                    plyrProj.y = _H + math.sin(rad)*(player.width/2) + player.y
                end
                --]]
                --[[
                local a
                local b
                if((player.rotation == -45) or (player.rotation == 45) or (player.rotation == 135) or (player.rotation == 225))then
                    player.rotation = player.rotation - 0.1
                end
                --replace _W and _H with player.x + _W and player.y + _H
                if(((player.rotation > 135) and (player.rotation < 225)) or ((player.rotation > -45) and (player.rotation < 45)))then
                    --use 1
                    if(player.rotation < 90)then
                        a = _W
                    else
                        a = 0
                    end
                    if(((player.rotation > -45) and (player.rotation < 0)) or ((player.rotation > 180) and (player.rotation < 225)))then
                        b = -1 * ((_W/2) * math.tan(rad))
                    else
                        b = (_W/2) * math.tan(rad)
                    end
                elseif((player.rotation > 225) or (player.rotation < -45) or ((player.rotation > 45) and (player.rotation < 135)))then
                    --use 2
                    if((player.rotation > 0) and (player.rotation < 180))then
                        b = _H
                    else
                        b = 0
                    end
                    if(((player.rotation > 90) and (player.rotation < 135)) or ((player.rotation > 225) and (player.rotation < 270)))then
                        a =  -1 * ((2 * math.tan(rad))/_H)
                    else
                        a = (2 * math.tan(rad))/_H
                    end
                end
                --]]
                physics.addBody(plyrProj, "dynamic", {density=10})
                plyrProj.isBullet = true
                local function mover()
                    local v = {}
                    local a = {}
                    a.base = 2 * aBase
                    if((plyrProj.rotation == 0) or (plyrProj.rotation == 180))then
                        a.x = a.base
                        a.y = 0
                    elseif((plyrProj.rotation == 90) or (plyrProj.rotation == 270))then
                        a.x = 0
                        a.y = a.base
                    else
                        a.x = (1/(90/(plyrProj.rotation % 90))) * a.base
                        a.y = a.base - a.x
                    end

                    if(not((plyrProj.rotation > 0) and (plyrProj.rotation < 180)))then
                        a.y = -a.y
                    end
                    if(not(plyrProj.rotation < 90))then
                        a.x = -a.x
                    end

                    v.x, v.y = plyrProj:getLinearVelocity()
                    if((v.x == 0) and (v.y == 0))then
                        local p = {}
                        p.x, p.y = player:getLinearVelocity()
                        if(a.x > 0)then
                            v.x = 4
                            if(p.x > 0)then
                                v.x = v.x + p.x
                            end
                        elseif(a.x == 0)then
                            v.x = 0.001 + p.x
                        else
                            v.x = -4
                            if(p.x < 0)then
                                v.x = v.x + p.x
                            end
                        end

                        if(a.y > 0)then
                            v.y = 4
                            if(p.y > 0)then
                                v.y = v.y + p.y
                            end
                        elseif(a.y == 0)then
                            v.y = 0.001 + p.y
                        else
                            v.y = -4
                            if(p.y < 0)then
                                v.y = v.y + p.y
                            end
                        end
                    end

                    plyrProj:setLinearVelocity(v.x + a.x, v.y + a.y)
                end

                local function baleet(collision)
                    if(cleanup == false)then
                        if(collision)then
                            timer.cancel(plyrProj.deathTime)
                            plyrProj.deathTime = nil
                        end
                        timer.cancel(plyrProj.moveTime)
                        plyrProj.moveTime = nil
                        plyrProj:removeSelf()
                        plyrProj = nil
                    end
                end
                function plyrProj:postCollision(e)
                    if(e.other ~= player)then
                        baleet(true)
                    end
                end
                plyrProj:addEventListener("postCollision", plyrProj)

                plyrProj.moveTime = timer.performWithDelay(10, mover, 0)
                plyrProj.deathTime = timer.performWithDelay(2500, baleet, 1)

                movables.projectiles.plyrProj = plyrProj

                conductor.playEffect(1)
            end
        end
    end

    function player:rotator(e)
        local xdiff = e.x - _W/2
        local ydiff = e.y - _H/2
        local h = math.sqrt((xdiff^2) + (ydiff^2))
        if(e.x > _W/2)then
            player.rotation = ((math.asin(ydiff/h)) * (180/math.pi))
        else
            player.rotation = 180 - (((math.asin(ydiff/h)) * (180/math.pi)))
        end
    end

    local function mover()
        if(cleanup == false)then
            if(fuel.percent > 0)then
                player:prepare("thrust")
                player:play()
                updateFuel(-1)
                local v = {}
                local a = {}
                a.base = aBase
                if((player.rotation == 0) or (player.rotation == 180))then
                    a.x = a.base
                    a.y = 0
                elseif((player.rotation == 90) or (player.rotation == 270))then
                    a.x = 0
                    a.y = a.base
                else
                    a.x = (1/(90/(player.rotation % 90))) * a.base
                    a.y = a.base - a.x
                end
                if(not((player.rotation > 0) and (player.rotation < 180)))then
                    a.y = -a.y
                end
                if(not(player.rotation < 90))then
                    a.x = -a.x
                end
                v.x, v.y = player:getLinearVelocity()

                player:setLinearVelocity(v.x + a.x, v.y + a.y)
            end
        else
            timer.cancel(player.moveTimer)
            player.moveTimer = nil
        end
    end

    function player:touch(e)
        if(active == true)then
            player:rotator(e)
            if(e.phase == "began")then
                --holdingCell.ex = e.x
                --holdingCell.ey = e.y

                player.moveTimer = timer.performWithDelay(1, mover, 0)
            elseif(e.phase == "moved")then
                --holdingCell.ex = e.x
                --holdingCell.ey = e.y
            elseif(e.phase == "ended")then
                if(player.moveTimer)then
                    timer.cancel(player.moveTimer)
                    player.moveTimer = nil
                    player:prepare("smoke")
                    player:play()
                    --holdingCell.ex = nil
                    --holdingCell.ey = nil
                    --holdingCell.a = nil
                end
            end
        end
    end
    Runtime:addEventListener("touch", player)

    function player:tap(e)
        if(active == true)then
            player:rotator(e)
            fire(e)
        end
    end
    Runtime:addEventListener("tap", player)

    --[[
    foreground.x = _W/2-player.x
    foreground.y = _H/2-player.y
    enviroment.x = _W/2-player.x
    enviroment.y = _H/2-player.y
    --]]

    physics.addBody(foreground, "dynamic")
    foreground.isSensor = true
    physics.addBody(enviroment, "dynamic")
    enviroment.isSensor = true

    --[[
    local function checkSun()
        local pw = player.width*player.xScale
        local ph = player.height*player.yScale
        local sw = solar.sun.width*solar.sun.xScale
        local sh = solar.sun.height*solar.sun.yScale
        if((player.x - pw ) )then

        end
    end
    --]]

    local function updateAll()
        --updateAV()
        --updatePositions()
        if(cleanup == true)then
            Runtime:removeEventListener("enterFrame", updateAll)
        else
            solar.sun:updateSun()
            updateScore()
            --[[
            foreground.x = _W/2-player.x
            foreground.y = _H/2-player.y
            enviroment.x = _W/2-player.x
            enviroment.y = _H/2-player.y
            --]]
            local vx, vy = player:getLinearVelocity()
            foreground:setLinearVelocity(-vx, -vy)
            enviroment:setLinearVelocity(-vx, -vy)
            background.x = _W/2-player.x
            background.y = _H/2-player.y
        end
    end
    Runtime:addEventListener("enterFrame", updateAll)

    Scene:insert(background)
    Scene:insert(enviroment)
    Scene:insert(foreground)
    Scene:insert(GUI)

    conductor.gameLoad()

    local function activate()
        active = true
    end
    timer.performWithDelay(500, activate)

    return Scene
end