module(..., package.seeall)

function new()
    local Scene = display.newGroup()
    local GUI = display.newGroup()
    local background = display.newGroup()

    local title = display.newImage("images/credits.png", _H/2, _W/2)
    title:setReferencePoint(display.CenterReferencePoint)
    title.x = _W - _W/10
    title.y = _H/2
    title.xScale = (_H - (_H/4))/title.width
    title.yScale = _W/10/title.height
    title.rotation = 90
    GUI:insert(title)

    local creds = display.newText("Designed and Developed by Andrew Hopkins\n\nBackground image created from a photograph property of Jim Keller\nused under a creative commons license.\n\nMusic created by:\n Cheshyre\n SasquaMox\n NemesisTheory\nAll used under a creatire commons license\n\nAll sound effects and other images owned by Andrew Hopkins", 0, _H/2, native.systemFont, 20)
    creds.rotation = 90
    --creds.x = title.x - (title.height*title.yScale)
    creds.x = _W/2
    creds.y = _H/2
    GUI:insert(creds)

    local function changeScene(e)
        if(e.phase == "began")then
            --e.target:setTextColor(244, 226, 21)
        elseif(e.phase == "moved")then
            --e.target:setTextColor(255,255,255)
        elseif(e.phase == "cancelled" or e.phase == "ended") then
            conductor.playEffect(1)
            background:removeSelf()
            GUI:removeSelf()
            background = nil
            GUI = nil
            director:changeScene(e.target.scene)
        end
    end

    local menu = display.newImage("images/btn_menu.png", 50, 50)
    menu:setReferencePoint(display.CenterReferencePoint)
    menu.x = _W/12
    menu.y = _H/2
    menu.rotation = 90
    menu.scene = "menu"
    menu:addEventListener("touch", changeScene)
    GUI:insert(menu)

    local back = display.newImage("images/menu_back.png", _W, _H)
    back.alpha = 0.75
    back:setReferencePoint(display.CenterReferencePoint)
    back.x = _W/2
    back.y = _H/2
    back.rotation = 90
    background:insert(back)

    Scene:insert(background)
    Scene:insert(GUI)

    return Scene
end